import java.util.ArrayList;

/**
 * Die Klasse Controller
 * verwaltet das Projekt
 * 
 * @author claus albowski
 * @version 5'2015
 */
public class Controller
{
    private ArrayList<Stueck> stuecke;
    private Container container;
    private ArrayList<Container> alternativen;
    
    /**
     * Konstruktor fuer Objekte der Klasse Controller
     */
    public Controller()
    {
        stuecke = new ArrayList();
        alternativen = new ArrayList();
    }
    
    /**
     * erzeugt einen neuen Container
     */
    public void neuerContainer(int fassungsvermoegen){
        container = new Container(fassungsvermoegen);
        alternativen.add(container);
    }

    /**
     * erzeugt ein neues Stueck
     */
    public void neuesStueck(int volumen){
        stuecke.add(new Stueck(volumen));
    }

    /**
     * fuellt den Container nach dem greedy Verfahren
     */
    public boolean fuelleGreedy()
    {
        for (Stueck stueck: stuecke) 
        container.fuelleEin(stueck);
        return container.istVoll();
    }
    
    /**
     * fuellt einen Container durch Breitensuche;
     * die Alternativen auf jeder Stufe des binaeren Baumes
     * sind das Stuecke einzufuellen oder nicht;
     * der Zugriff auf die Stuecke erfolgt ueber den Index
     * diese Methode ruft nur die private rekursive Methode auf.
     */
    public boolean fuelleBS()
    {
        fuelleBS(0, alternativen, new ArrayList());
        return container.istVoll();
    }
    private void fuelleBS(int i,
                          ArrayList<Container> alternativen,
                          ArrayList<Container> aktuellGeneriert)
    {
        for (Container alternative : alternativen)
        {
            if ((alternative.gibFuellung() >= container.gibFuellung())
            && (alternative.gibFuellung() <= container.gibGroesse()))
            container = alternative; // aktuell besten sichern
            if (alternative.istVoll()) return;
            if (i<stuecke.size())  // noch Stuecke vorhanden?
            {
                Container alternativeMitStueck = new Container(alternative);
                if (alternativeMitStueck.fuelleEin(stuecke.get(i))) // geht es hinein?
                aktuellGeneriert.add(alternativeMitStueck);
                aktuellGeneriert.add(alternative);
            }
        }
        if (i<stuecke.size())
        fuelleBS(i+1, aktuellGeneriert, new ArrayList());
    }
    
    /**
     * zeigt das Ergebnis an.
     */
    public void zeigeErgebnis(){
        System.out.println("Der Container mit dem Fassungsvermoegen: "+container.gibGroesse()+" enthaelt: ");
        for (Stueck stueck : container.gibStuecke()) System.out.print(stueck.gibGroesse()+" ");
        System.out.println();
        if (container.istVoll()) System.out.println("Er ist vollstaendig gefuellt.\n");
        else System.out.println("Er konnte nicht vollstaendig gefuellt werden.\n");
    }
}
